#ifndef MODEOPTSPANEL_H
#define MODEOPTSPANEL_H

class TempModeOpts
{
    public:
        TempModeOpts( smallSyntax * aSyntax );
        ~TempModeOpts();
        void Apply();
        bool m_line, m_fold, m_wrap, m_indent, m_usetabs,
                m_viewws, m_horizSb, m_vertSb;
        wxColour m_pageColor;
        wxColour m_lineForeColor;
        wxColour m_lineBackColor;
        wxColour m_foldColor;
        wxColour m_indentColor;
        wxColour m_selColor;  ///selection color
        wxString m_tabWidth;
        smallSyntax * m_syntax;
    private:
};

//class TempModeOpts;
//WX_DECLARE_STRING_HASH_MAP( TempModeOpts *, TMO );

class ModeOptsPanel: public wxPanel    //! One for each language mode
{
    public:
        ModeOptsPanel( wxWindow * parent,  smallSyntax * aSyntax, wxPoint pos, int parentWidth );
        ~ModeOptsPanel();
        void OnCheck(wxCommandEvent &event);
        void MOPLoadWidgets();
        void SaveState();
        wxColour ChooseColor(wxColour &);
        void OnFold(wxCommandEvent & );
        void OnSel(wxCommandEvent & );
        wxCheckBox * m_line;
        wxCheckBox * m_fold;
        wxCheckBox * m_wrap;
        wxCheckBox * m_indent;
        wxCheckBox * m_usetabs;
        wxCheckBox * m_viewws;
        wxCheckBox * m_horizSb;
        wxCheckBox * m_vertSb;
        wxComboBox * m_tabWidth;
        wxButton * m_textPageButton;  ///For text mode only [Page Style]
        wxButton * m_otherColorBut;
        wxButton * m_pageColorBut;
        wxButton * m_lineStyleButton;
        wxButton * m_indentButton;
        wxButton * m_foldButton;
        wxButton * m_selButton;
        wxColour m_otherColor;
        wxColour m_pageColor;
    private:
        void OnSetBack(wxCommandEvent & );
        void OnOther(wxCommandEvent & );
        void OnPage(wxCommandEvent & );
        void OnLineStyle(wxCommandEvent & );
        void OnIndent(wxCommandEvent & );
        void OnPageStyle( wxCommandEvent & );
        smallSyntax * m_syntax;
        wxString m_index;
        bool m_textMode;
        wxPoint m_pos;  ///Store parent dialog position
        int m_parentWidth;
        wxRadioButton * m_rb1;
        wxRadioButton * m_rb2;
    DECLARE_EVENT_TABLE()
};

#endif