// AUTHOR: Rohan Allison
// COPYRIGHT: 2006
//  License: Artistic

#ifndef GLOBALDEFS_H   
#define GLOBALDEFS_H
/// Global definitions

//! global print data, to remember settings during the session
extern wxPrintData *g_printData;
extern wxPageSetupData *g_pageSetupData;

extern wxArrayString g_faceNames; //! Array to hold faceNames
extern wxArrayString g_recentDirs;
extern wxColour customColors[];
//extern int g_lineNum;  //Testing
extern int g_eolMode;
extern bool g_autoBook;
extern bool g_autoZoom;
extern bool g_acActive;
extern bool g_ctActive;
extern int g_numACChars;
extern int g_lineNumWidth;
extern int g_extInitLexer; ///For external lexer selection on start
extern wxString g_initialZoom;
extern wxString g_pathToBrowser;
extern wxString g_pathToApi;

//! global application name
extern wxString *g_zappname;

extern const wxChar *TITLE;
//extern const wxChar *AUTHOR;
// #define wxUSE_DDE_FOR_IPC 0
#define IPC_SERVICE _T("ZionEdit")  //Service must be a port num. for non-DDE

///Quote Mode for Attribute AC
#define SINGLEQUOTE 1
#define DOUBLEQUOTE 2
#define NOQUOTE -1

#define READSTYLES 1
#define READHISTORY 2
#define READPRINT 4  /// printing settings

///Syntax mode option FLAGS ( != Checkbox IDs further down)
#define  ZION_OPT_LINE 1
#define  ZION_OPT_FOLD 2
#define  ZION_OPT_WRAP 4
#define  ZION_OPT_INDENT 8
#define  ZION_OPT_USETABS 16
#define  ZION_OPT_VIEWWS 32
#define  ZION_OPT_HORIZSB 64
#define  ZION_OPT_VERTSB 128

#define NUMWINDOWS 20 ///Max number of windows that can be listed in the popup menu.
#define NUMBOOKMARKS 22 ///Max number of bookmarks that can be listed in the popup menu.

#define NUMEXECSTRS  22
#define NUMRECENTFILES 40
#define TOPRECENTFILES   10  ///We would like to make these user configurable
#define NUMRECENTDIRS   34

//! IDs shared by our Window Frame and our Stc control
enum {
    // menu IDs
    ZION_EXIT = wxID_HIGHEST +1, //Make sure we are starting with unused IDs
    ZION_IPCTIMER,
    ZION_BOOKMARKTIMER,
    ZION_OPEN, ZION_OPENSELECTED,
    ZION_SAVE, ZION_SAVE_AS,
    ZION_EXTERNALCLOSE,
    ZION_EXTERNALRAISE,
    ZION_SUBPROCESS,
    ZION_RUNANDCAPTURE,
    ZION_CAPTUREOUT,
    ZION_SELECTWORD,
    ZION_CLEARSTATUS,
    ZION_DUMPCALLTIPS,
    ZION_ASSOCTYPE,
    ZION_GOOGLEIT,
    ZION_WRITEINI,
    ZION_READINI, /**base **/
    ZION_READINI_STYLES,
    ZION_READINI_PRINT,
    ZION_READINI_HISTORY, /**upper limit */
    
    ZION_EDITINI,
    ZION_EDIT_HISTORY_INI,
    ZION_EDITAPI,
    ZION_CMDPROMPT,
    ZION_BUGREPORT,
    ZION_ONLINEDOCS,
    ZION_CHECKLATEST,
    ZION_EXPLORE,
    ZION_FILECLOSE,
    ZION_NEWZION, /** Base **/
    ZION_NEWZION_TL,
    ZION_NEWZION_BL,
    ZION_NEWZION_BR,
    ZION_NEWZION_TR,
    ZION_NEWZION_T,
    ZION_NEWZION_L,
    ZION_NEWZION_R,
    ZION_NEWZION_B,
    ZION_NEWZION_C,
    ZION_NEWZION_M, /** Upper Limit **/
    
    ZION_NEWHTML_SUB,
    ZION_NEWHTML_TEMPLSTRICT,
    ZION_NEWHTML_TEMPLTRANS,
    ZION_NEWHTML_TEMPLBASIC,
    ZION_NEWHTML_TEMPLBASICNH,
    ZION_NEWHTML_TEMPLASP,
    ZION_NEW, /*! base*/
    ZION_NEWNULL, //! text
    ZION_NEWPYTHON, ZION_NEWCPP,
    ZION_NEWHTML, ZION_NEWXML,
    ZION_NEWPERL, ZION_NEWSQL,
    ZION_NEWVB, ZION_NEWPROPS,
    ZION_NEWERROR, ZION_NEWMAKE,
    ZION_NEWBATCH, ZION_NEWJAVA, ///Overrode XCODE with Java
    ZION_NEWLATEX,   ZION_NEWCS, ///Overrode LUA with C#
    ZION_NEWDIFF,  ZION_NEWCONF,
    ZION_NEWPASCAL, ZION_NEWAVE,
    ZION_NEWADA, ZION_NEWLISP,
    ZION_NEWRUBY,///Short cut ///CAREFUL!!
    ZION_NEWVBSCRIPT = ZION_NEWRUBY + 6, ///Short cut ///CAREFUL!!
    ZION_NEWASM = ZION_NEWRUBY + 12, ///Short cut ///CAREFUL!!
    ZION_NEWCPPNOCASE,
    ZION_NEWFORTRAN,
    ZION_NEWF77,
    ZION_NEWCSS,
    
    ZION_FILEMENU,
    ZION_PRINTSETUP,
    ZION_PRINT,
    ZION_PRINTPREVIEW,
    ZION_TOGGLE,
    ZION_FULLSCRN_TOGGLE,
    ZION_CTAC_TOGGLE, 
    ZION_AUTOCOMP_TOGGLE, 
    ZION_CALLTIPS_TOGGLE, 
    ZION_LINE_TOGGLE, 
    ZION_FOLD_TOGGLE,
    ZION_WHITESPACE_TOGGLE,
    ZION_WRAP_TOGGLE,
    ZION_INDENT_TOGGLE,
    ZION_USETABS_TOGGLE,
    ZION_READONLY_TOGGLE,
    ZION_AUTOZOOM_TOGGLE,
    ZION_AUTOBOOK_TOGGLE,
    ZION_STATUSBAR_TOGGLE,
    ZION_HORIZSB_TOGGLE,
    ZION_VERTSB_TOGGLE,
    
    ZION_EDITMENU,
    ZION_UNDO,
    ZION_REDO,
    ZION_COPY,
    ZION_CUT,
    ZION_PASTE,
    
    //ZION_FINDSUBMENU,
    ZION_FIND,
    ZION_FINDALL,
    ZION_RTFIND,
    ZION_FIND_COMBO,
    ZION_FIND_TEXT,
    ZION_REPL_TEXT,
    ZION_FIND_LIST,
    ZION_FINDALLFILES,
    ZION_FINDREPLACE,
    ZION_FINDNEXT,
    ZION_FINDPREV,
    ZION_FR_SYNCH,
    ZION_FR_REPLMODE,
    ZION_FR_FIND_COMBO,
    ZION_FR_REPL_COMBO,
    //ZION_FR_REPLACE_COMBO,
    ZION_FR_FIND_TEXT,
    ZION_FR_TWEAKFLAGS,
    ZION_FR_WHOLEWORD,
    ZION_FR_MATCHCASE,
    ZION_FR_PRESERVE,
    ZION_FR_PRESERVECASE,
    ZION_FR_FIND,
    ZION_FR_REGEX,
    ZION_FR_REPLSELS,
    ZION_FR_REPLALL,
    ZION_FR_REPLACE,
    ZION_FR_REPLACE_ALL,
    ZION_FR_CLEAR,
    ZION_FR_SEARCHAGAIN,
    ZION_FR_CLEAR_FIND,
    ZION_FR_CLEAR_REPL,
    ZION_FR_ALLFILES,
    ZION_DIRBROWSE,
    ZION_EXEC_DIRBROWSE,
    ZION_EXEC_COMBO,
    ZION_FRES_LISTBOX,
    ZION_RLISTBOX,
    ZION_ALLFILES_LISTBOX,
    ZION_FAF_CLOSESW,
    ZION_FAF_REPLTEXT,
    ZION_FAF_PRESERVECASE,
    ZION_FAF_REPLACE,
    ZION_FAF_YESTOALL,
    
    ZION_SELECTRECT,
    ZION_AUTOCOMPSHOW,
    ZION_CALLTIPSHOW,
    ZION_CONTEXTCALLTIP,
    ZION_REMOVEBLANKS,
    ZION_REMOVE1BLANK,
    ZION_REMOVEALLBLANKS,
    ZION_REMOVEGT2BLANKS,
    
    ZION_LINEOPS,
    ZION_SPECIALOPS,
    ZION_CUTLINE,
    ZION_COPYLINE,
    ZION_SELECTLINE,
    ZION_SELECTALL,
    ZION_DUPLICATELINE,
    ZION_TRANSPOSELINE,
    ZION_INCINDENT,
    ZION_REDINDENT,
    ZION_UPPERCASE,
    ZION_LOWERCASE,
    ZION_ZOOMIN,
    ZION_ZOOMOUT,
    ZION_RESETZOOM,
    
    ZION_GOTO,
    ZION_GOTOBRACE,
    ZION_GOTOLINE,
    ZION_GOTOSTART,
    ZION_GOTOEND,
    ZION_SELTOBRACE,
    
    ZION_LINE,
    ZION_LINE_WINDOWS, //! base
    ZION_LINE_MAC,
    ZION_LINE_UNIX,
    
    ZION_FORCESYNTAX,
    ZION_SETTINGS,
    ZION_COLOURVALUE,
    //ZION_CHOOSEFONT,
    
    ZION_INI_BROWSE,
    ZION_BROWSE_BROWSER, ///BROWSE to Web Browser
    ZION_BROWSE_API, ///BROWSE to API files
    ZION_API_USEDEF,
    ZION_USECURRENT,
    
    //Various Dialog Events
    ZION_STYLE,
    ZION_MODE_OPTS,
    ZION_STYLE_FORE,
    ZION_STYLE_BACK,
    ZION_STYLE_PAGE,
    ZION_STYLE_BOLD,
    ZION_STYLE_ITALIC,
    ZION_STYLE_FACE,
    ZION_STYLE_SIZE,
    ZION_STYLE_PAGEFORE,
    ZION_STYLE_USEPAGE,
    ZION_STYLE_CARET,
    ZION_STYLE_INDENT,
    ZION_STYLE_SEL,
    ZION_STYLE_LINENUM,
    ZION_STYLE_FOLD,
    ZION_STYLE_BRACEHILITE,
    ZION_STYLE_BRACEBAD,
    ZION_LINEFORE,
    ZION_LINEBACK,
    ZION_FOLDCOLOR,
    ZION_SELCOLOR,
    ZION_SHOWWORDS,
    ZION_THISWINCHECK,
    ZION_NEWWINCHECK,
    ZION_NEWWINSELECTED,
    
    ZION_OPTS_LINE,
    ZION_OPTS_FOLD,
    ZION_OPTS_WRAP,
    ZION_OPTS_INDENT,
    ZION_OPTS_USETABS,
    ZION_OPTS_VIEWWS,
    ZION_OPTS_HORIZSB,
    ZION_OPTS_VERTSB,
    
    ZION_OPTS_STARTNORM,
    ZION_OPTS_STARTMAX,
    ZION_OPTS_STARTCUSTOM,
    
    ZION_OPTS_RADIOPAGE,
    ZION_OPTS_RADIOOTHER,
    ZION_OPTS_PAGECOLOR,
    ZION_OPTS_OTHERCOLOR,
    ZION_OPTS_SETBACK,
    ZION_APPLY,
    ZION_ELEMENTSLISTBOX,
    ZION_EOL_MODE,
    ZION_TABWIDTH,
    
    ZION_MODESLISTBOX,
    ZION_EXTCOMBO,
    ZION_EXTMSG,
    
    ZION_JUSTLOADED,   //event to reset the modified state
    ZION_RELOAD,

    ZION_CONTAINER, /*! base */  ///These MUST be in lexer order
    ZION_NULL,
    ZION_PYTHON,    ZION_CPP,
    ZION_HTML,    ZION_XML,
    ZION_PERL,    ZION_SQL,
    ZION_VB,    ZION_PROPS,
    ZION_ERROR,    ZION_MAKE,
    ZION_BATCH,    ZION_JAVA,  ///Overrode XCODE with Java
    ZION_LATEX,   ZION_CS, ///Overrode LUA with CS
    ZION_DIFF,  ZION_CONF,
    ZION_PASCAL, ZION_AVE,
    ZION_ADA, ZION_LISP,
    ZION_RUBY,
    ZION_VBSCRIPT = ZION_RUBY + 6,
    ZION_ASM = ZION_RUBY + 12,
    ZION_CPPNOCASE,
    ZION_FORTRAN,
    ZION_F77,
    ZION_CSS,
    
    ///MODE SPECIFIC MENUS
    ZION_HTMLMENU,
    ZION_HTML_EMBED,
    ZION_HTML_MATCHTAG,
    ZION_HTMLPREVIEW,
    ZION_HTML_AC_TOGGLE,
    ZION_HTML_BR_TOGGLE,
    ZION_HTMLMENU_BR,
    ZION_HTMLMENU_BOLD,
    ZION_HTMLMENU_ITALIC,
    ZION_HTMLMENU_UNDERLINE,
    ZION_HTMLMENU_EM,
    ZION_HTMLMENU_PARAGRAPH,
    ZION_HTMLMENU_CENTER,
    ZION_HTMLMENU_STRONG,
    ZION_HTMLMENU_ANCHOR,
    ZION_HTMLMENU_FORM,
    ZION_HTMLMENU_BLOCKQUOTE,
    ZION_HTMLMENU_FONT,
    ZION_HTMLMENU_SPAN,
    ZION_HTMLMENU_CODE,
    ZION_HTMLMENU_SUPTH,
    ZION_HTMLHEADINGMENU,
    ZION_HTMLMENU_H3,
    ZION_HTMLMENU_H1,
    ZION_HTMLMENU_H2,
    ZION_HTMLMENU_H4,
    ZION_HTMLMENU_LI,
    ZION_HTMLMENU_UL,
    ZION_HTMLMENU_OL,
    ZION_HTMLLISTMENU,
    ZION_HTMLMOREMENU,
    ZION_HTMLMENU_STYLE,
    ZION_HTMLMENU_BACKGROUNDCOLOR,
    ZION_HTMLMENU_PADDINGLEFT,
    ZION_HTMLMENU_COMMENT,
    ZION_HTMLMENU_UNCOMMENT,
    ZION_HTMLMENU_QUICKTAG,
    ZION_HTMLMENU_NBSP,
    ZION_HTMLMENU_NDASH,
    ZION_HTMLMENU_SUP,
    ZION_HTMLTABLEMENU,
    ZION_HTMLMENU_TABLE,
    ZION_HTMLMENU_TD,
    ZION_HTMLMENU_TR,
    ZION_HTMLMENU_TH,
    ZION_HTMLMENU_PRE,
    ZION_HTMLMENU_QUOTE,
    ZION_HTMLMENU_SKIPTAG,
    ZION_HTMLMENU_SKIPBEFORETAG,
    ZION_HTMLSTYLEMENU,
    ZION_HTML_PHP,
    ZION_HTML_ASP,
    ZION_HTML_ASPDRTV,
    ZION_HTML_ASPNET,  /// Dot Net
    ZION_HTML_SCRIPT,
    
    ZION_HTML_TEMPL, ///Submenu
    ZION_HTML_TEMPLASP,
    ZION_HTML_TEMPLBASIC,
    ZION_HTML_TEMPLBASICNOHEAD,
    ZION_HTML_TEMPLTRANS,
    ZION_HTML_TEMPLSTRICT,
    
    ZION_CPPMENU,
    ZION_CPPMENU_CURLY,
    ZION_CPPMENU_FOR,
    ZION_CPPMENU_IF,
    ZION_CPPMENU_ELSE,
    ZION_CPPMENU_ELSEIF,
    ZION_CPPMENU_WHILE,
    ZION_CPPMENU_DOWHILE,
    ZION_CPPMENU_COMMENT,
    ZION_CPPMENU_UNCOMMENT,
    ZION_CPPMENU_LINECOMMENT,
    ZION_CPPMENU_LINEUNCOMMENT,
    ZION_CPPMENU_T,
    
    ZION_RUBYMENU,
    ZION_VBSCRIPTMENU,
    ZION_VBMENU_IF,
    ZION_VBMENU_ELSE,
    ZION_MAKEMENU,
    ZION_LISPMENU,
    ZION_FORTRANMENU, ///Fortran 90
    ZION_FORTRAN77MENU, ///Fortran77
    ZION_ASMMENU,
    ZION_BATCHMENU,
    ZION_CSSMENU,
    ZION_SQLMENU,
    ZION_PYTHONMENU,
    ZION_PERLMENU,
    ZION_PERLMENU_ELSIF,
    ZION_PERLMENU_FOREACH,
    ZION_PERLMENU_LINECOMMENT,
    ZION_PERLMENU_LINEUNCOMMENT,
    ZION_VBMENU_LINECOMMENT,
    ZION_VBMENU_LINEUNCOMMENT,
    ZION_SQLMENU_LINECOMMENT,
    ZION_SQLMENU_LINEUNCOMMENT,
    ZION_FORTRAN77MENU_LINECOMMENT,
    ZION_FORTRAN77MENU_LINEUNCOMMENT,
    ZION_FORTRANMENU_LINECOMMENT,
    ZION_FORTRANMENU_LINEUNCOMMENT,
    ZION_ASMMENU_LINECOMMENT,
    ZION_ASMMENU_LINEUNCOMMENT,
    ZION_BATCHMENU_LINECOMMENT,
    ZION_BATCHMENU_LINEUNCOMMENT,
    ZION_BATCHMENU_LINECOMMENT2,
    ZION_BATCHMENU_LINEUNCOMMENT2,
    
    ZION_RECENTDIRS,
    ZION_DIR_1,    /*! Base */
    ZION_DIR_LAST = ZION_DIR_1 + NUMRECENTDIRS - 1,
    ZION_OPENITEM_1,    /*! Base */  ///Each submenu will have an open item
    ZION_OPENITEM_LAST = ZION_OPENITEM_1 + NUMRECENTDIRS - 1,
    ZION_REMOVEITEM_1,    /*! Base */  ///Each submenu will have an remove item
    ZION_REMOVEITEM_LAST = ZION_REMOVEITEM_1 + NUMRECENTDIRS - 1,

    ZION_BOOKMARKS,
    ZION_BOOK_1,  /*! Base */
    ZION_BOOK_LAST = ZION_BOOK_1 + NUMBOOKMARKS -1,
    ZION_ADDBOOKMARK,
    ZION_CLEARBOOKMARKS,

    ZION_WINDOWS,
    ZION_WIN_1,  /*! Base */
    ZION_WIN_LAST = ZION_WIN_1 + NUMWINDOWS -1,

    ZION_RECENTFILES,
    ZION_FILE_1,  /*! Base */
    ZION_FILE_LAST = ZION_FILE_1 + NUMRECENTFILES -1,
    
    ZION_FILEITEM_1,    /*! Base */
    ZION_FILEITEM_LAST = ZION_FILEITEM_1 + (NUMRECENTDIRS * NUMRECENTFILES) - 1,
    
    ZION_BECOMESERVER,
    ZION_ADVISE_READHISTORY,
    ZION_ADVISE_READSTYLES,
    ZION_ADVISE_READPRINT,
    ZION_ADVISE_FINDUPDATE,
    ZION_ADVISE_REPLUPDATE,
    ZION_ADVISE_CLOSE,
    ZION_ADVISE_RAISE,
    ZION_FINDUPDATE,
    ZION_REPLUPDATE,
    ZION_NOTIFYSTYLES,
    ZION_NOTIFYPRINT,
    ZION_MENURECONN,
    ZION_RECONN,
    ZION_SHOWIPCSTATUS,
    ZION_ASSIGNPRIORITIES,
    ZION_IPCSUBMENU,
//    ZION_SHOWPRIORITY,
    ZION_HELP,
    ZION_INFO,
    ZION_ABOUT
};

#endif //GLOBAL_DEFS_H
